<?php

/*
Plugin Name: Simple Retail Menus
Plugin URI: http://whatwouldjessedo.com/simple-retail-menus/
Description: Create and manage salon, restaurant, or retail store menu lists of services, food items, retail items, or other data.
Author: Jesse Cortez
Author URI: http://whatwouldjessedo.com/
Version: v1.1

Copyright 2011  Jesse Cortez  (email : whatwouldjessedo at gmail.com)

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110, USA
*/

/********* INSTALL DB TABLE FUNCTION ****/


global $wpdb;
global $jsrm_db_version;
$jsrm_db_version = "1.0";

global $jsrm_menu_table;
$jsrm_menu_table = $wpdb->prefix . "jsrm_menus";

global $jsrm_item_table;
$jsrm_item_table = $wpdb->prefix . "jsrm_items";

function simpleretailmenus_install() {
	global $wpdb;
	global $jsrm_db_version;
	global $jsrm_menu_table;
	global $jsrm_item_table;
	
	$sql1 = "CREATE TABLE IF NOT EXISTS `" . $jsrm_menu_table . "` (
	  id mediumint(9) NOT NULL AUTO_INCREMENT,
	  name tinytext NOT NULL,
	  description text,
	  UNIQUE KEY id (id)
	);";
	
	$sql2 = "CREATE TABLE IF NOT EXISTS " . $jsrm_item_table . " (
	  id mediumint(9) NOT NULL AUTO_INCREMENT,
	  menu mediumint(9) NOT NULL,
	  itemorder mediumint(9) NOT NULL,
	  item tinytext NOT NULL,
	  value VARCHAR(255) NOT NULL,
	  description text,
	  UNIQUE KEY id (id)
	);";
	
	require_once(ABSPATH . 'wp-admin/includes/upgrade.php');
	
	dbDelta($sql1);
	dbDelta($sql2);
	
	add_option("jsrm_db_version", "$jsrm_db_version");
}

register_activation_hook(__FILE__,'simpleretailmenus_install'); 



// ADD JS SCRIPTS TO PLUGIN HEAD

function jsrm_admin_head(){
	wp_enqueue_script( 'jquery' );
   
    wp_register_script( 'tabledragdrop', plugins_url('jquery.tablednd_0_5.js', __FILE__),array('jquery'));
    wp_enqueue_script( 'tabledragdrop' );
    
    wp_enqueue_script( 'tabletest', plugins_url('simple-retail-menus.js', __FILE__),array('jquery','tabledragdrop'));
    wp_enqueue_script( 'tabletest' );
}

// ADD STYLES TO PLUGIN HEAD

function jsrm_admin_stylesheet() {
       wp_register_style( 'adminstyles', plugins_url('admin.css', __FILE__));
       wp_enqueue_style( 'adminstyles' );
}

// ADD THE PLUGIN MENU TO THE ADMIN PAGE

function jsrm_menu() {
	$jsrmpluginpage = add_menu_page( 'Retail Menus', 'Retail Menus', 'manage_options', 'jsrm-retail-menus', 'display_page');
	
	add_action( 'admin_init', 'jsrm_admin_stylesheet' );
	add_action( "admin_print_scripts-$jsrmpluginpage", 'jsrm_admin_head' );
	

}
add_action('admin_menu', 'jsrm_menu');

// ADD STYLES TO POSTS PAGES

function jsrm_stylesheet() {
	$myStyleUrl = WP_PLUGIN_URL . '/simple-retail-menus/display.css';
	$myStyleFile = WP_PLUGIN_DIR . '/simple-retail-menus/display.css';
	if ( file_exists($myStyleFile) ) {
		wp_register_style('myStyleSheets', $myStyleUrl);
		wp_enqueue_style( 'myStyleSheets');
	}
}
add_action('wp_print_styles', 'jsrm_stylesheet');   

// REGISTER SHORTCODE and RENDER OUTPUT

function jsrm_shortcode( $atts ) {
	global $wpdb;
	global $jsrm_menu_table;
	global $jsrm_item_table;

	extract( shortcode_atts( array(
		'name' => 'menuname',
		'class' => 'jsrm-menu',
		'header'=>'h2',
		'desc' => 'p',
		'display' => 'table'
		), $atts ) );
	
	$mylink = $wpdb->get_row("SELECT * FROM $jsrm_menu_table WHERE name = '$name'");
	$filter = $mylink->id;
	$menuname = html_entity_decode(esc_html(stripslashes($mylink->name)));
	$menudescription = html_entity_decode(esc_html(stripslashes($mylink->description)));
	
	$q = "SELECT * FROM $jsrm_item_table WHERE menu = '$filter' ORDER by itemorder ASC";
	$result = $wpdb->get_results($q);
	
	if ($result) { 
		ob_start();
		include('display.php');
		$menudump = ob_get_clean();
		return $menudump;
	}
}
add_shortcode( 'simple-retail-menu', 'jsrm_shortcode' );


///__DATABASE FUNCTIONS__/////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////


global $generateshortcode;
$generateshortcode = "hiya";

//__DELETE MENU______________________________________________________

if(isset($_GET['dbtouch'])){	
	if ($_GET['dbtouch'] == "deletemenu"){
		$targetmenu = $_GET['targetmenu'];
		$wpdb->query("DELETE FROM $jsrm_item_table WHERE menu = $targetmenu");
		$wpdb->query("DELETE FROM $jsrm_menu_table WHERE id = $targetmenu");	
		$loc =  $_SERVER["PHP_SELF"]."?page=jsrm-retail-menus";
	}
}
	
if(isset($_POST['dbtouch'])){
	
//__ADD MENU________________________________________________________
	
	if($_POST['dbtouch'] == "addmenu"){
		$name = preg_replace('/\s\s+/', ' ', $_POST['name']);
		 if (isset($name) && $name != "" && $name !=" "){
			$description = $_POST['desc'];
			$wpdb->insert( $jsrm_menu_table , array( 'name' => $name, 'description' => $description ), array( '%s', '%s' ) );
			$targetmenu = $wpdb->insert_id;
			$menuslug = "jsrm".$targetmenu;
			
			$loc =  $_SERVER["PHP_SELF"]."?page=jsrm-retail-menus&mode=editmenu&targetmenu=".$targetmenu;

		}
		else{
			$loc =  $_SERVER["PHP_SELF"]."?page=jsrm-retail-menus&mode=newmenu&error=namefield";	
		}
	}
	
	
//__UPDATE MENU______________________________________________________

	else if ($_POST['dbtouch'] == "updatemenu"){
		$name = preg_replace('/\s\s+/', ' ', $_POST['name']);
		if (isset($name) && $name != "" && $name !=" "){
			$description = $_POST['desc'];
			$id = $_POST['targetmenu'];
			$wpdb->update( $jsrm_menu_table, array( 'name' => $name , 'description' => $description ), array( 'id' => $id ), array( '%s', '%s' ) );
			$loc =  $_SERVER["PHP_SELF"]."?page=jsrm-retail-menus&mode=editmenu&targetmenu=".$_POST['targetmenu'];
		}
		else{
			$loc =  $_SERVER["PHP_SELF"]."?page=jsrm-retail-menus&mode=editmenu&targetmenu=".$_POST['targetmenu']."&error=namefield";	
		}
	}
	
	
//__ADD ITEM________________________________________________________

	else if ($_POST['dbtouch'] == "additem"){
		$targetmenu = $_POST['targetmenu'];
		$num_rows = $wpdb->query("SELECT * FROM $jsrm_item_table WHERE menu = $targetmenu");
		$neworder = $num_rows+1;
			
		if ($_POST['item']){
			$item = $_POST['item'];
			$value = $_POST['value'];
			$description = $_POST['desc'];
			
			$wpdb->insert( $jsrm_item_table , array( 'itemorder' => $neworder, 'item' => $item, 'value' => $value, 'menu' => $targetmenu, 'description' => $description ), array( '%s', '%s', '%s' , '%s' ) );		
		}
		
		$loc =  $_SERVER["PHP_SELF"]."?page=jsrm-retail-menus&mode=editmenu&targetmenu=".$_POST['targetmenu'];
	}
	

//__EDIT ITEMS______________________________________________________


	else if ($_POST['dbtouch'] == "edititems"){
		
		foreach($_POST['id'] as $j){

			if (isset($_POST['item'][$j])){
				$item = $_POST['item'][$j];
			}
			if (isset($_POST['desc'][$j])){
				$desc = $_POST['desc'][$j];
			}
			if (isset($_POST['value'][$j])){
				$value = $_POST['value'][$j];
			}
			if (isset($_POST['order'][$j])){
				$order = $_POST['order'][$j];
			}
			
			if (isset($_POST['strike'][$j]) && $_POST['strike'][$j] == 'checked' ){
				$wpdb->query("DELETE FROM $jsrm_item_table WHERE id = $j");
			}
			else{
				$wpdb->update( $jsrm_item_table , array( 'item' => $item, 'itemorder' => $order, 'description' => $desc, 'value' => $value, ),array( 'id' => $j ), array( '%s', '%s', '%s', '%s' ) );
			}

		}
		//Sort items by order, then rewrite the orderw ith no gaps left from deleted items
		$targetmenu = $_POST['targetmenu'];
		
		$rows = "SELECT * FROM $jsrm_item_table WHERE menu = $targetmenu ORDER by itemorder ASC";
		$result = $wpdb->get_results($rows);
		$n = 1;
		foreach ($result as $r){
			$id = $r->id;
			$wpdb->update( $jsrm_item_table , array( 'itemorder' => $n ),array( 'id' => $id ), array( '%s' ) );
			++$n;
		}
		
		$loc =  $_SERVER["PHP_SELF"]."?page=jsrm-retail-menus&mode=editmenu&targetmenu=".$_POST['targetmenu'];
	}
	
	

	// END of if....
	header("Location: ".$loc);
	exit();

}

///__PAGE DISPLAY__/////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////

if (!isset($_GET['mode'])){
	$mode = "home";
	} 
else if (isset($_GET['mode'])){
	if($_GET['mode'] == "newmenu"){
		$mode = "newmenu";
	}
	else if ($_GET['mode'] == "editmenu"){
		$mode = "editmenu";
	}
	else {
		$mode = "home";
	}	
}

function display_page() {

	if (!current_user_can('manage_options'))  {
		wp_die( __('You do not have sufficient permissions to access this page.') );
	}
	?>
	
	<div class="wrap jsrm">
	<h2>Simple Retail Menus</h2>
	
	
	<?php
	
	global $wpdb;
	global $mode;
	global $jsrm_menu_table;
	global $jsrm_item_table;
	
	$self = $_SERVER["PHP_SELF"]."?page=jsrm-retail-menus";
		
//SHOW HOME SCREEN______________________________________________________

	if ($mode == "home"){ 
		$q = "SELECT * FROM $jsrm_menu_table";
		$result = $wpdb->get_results($q);
		?>
		<p><a href="<?php echo $self."&mode=newmenu"; ?>">Add New Menu</a></p>
		
				<?php
				if ($result) {
					?>
					<table id="jsrm-current-menu-list" class="widefat">
						<thead>
							<tr><th>Menu</th><th>Description</th></tr>
						</thead>
						<tbody>
					<?php
					foreach ($result as $r) {
						$name= esc_html(stripslashes($r->name));
						if($r->description){
							$description= esc_html(stripslashes($r->description));
						}
						else{
							$description = "&nbsp;";
						}
						$target= $r->id;
						$editlink = $self."&mode=editmenu&targetmenu=".$target;
						$num_rows = $wpdb->query("SELECT * FROM $jsrm_item_table WHERE menu = $target");
						?>
						<tr>
							<td><a href="<?php echo $editlink; ?> "><?php echo $name ?></a> (<?php echo $num_rows ?>)</td>
							<td><?php echo $description ?></td>
						</tr>
					<?php
					}
					?>
						</tbody>
					</table>
				<?php
				}
	}
	
	
//NEW MENU SCREEN______________________________________________________

	else if ($mode == "newmenu"){
		$message = (isset($_GET['error']) && $_GET['error'] == "namefield") ?  "<span style='color:red;'>Please give your menu a name.</span>" : "Menu Name";

			?>
				<form action="<?php echo $_SERVER["REQUEST_URI"]; ?>" method="post">
				<table class="widefat jsrm-admin-table">
					<thead>
						<tr><th colspan="2">Create a new menu</tr>
					</thead>
					<tbody>
						<tr>
							<td>
								<div><label for="name"><?php echo $message; ?></label><br/><input id="menu-title" type="text" name="name" /></div>
								<div><label>Description</label><br/>
								<textarea rows="4" cols="60" name="desc" id="menu-description"/></textarea></div>
								<input type="hidden" name="dbtouch" value="addmenu" />
								<p><input type="submit" value="Add Menu"/></p>
							</td>
							<td>
								<a href="<?php echo $self; ?>" class="cancelation">Cancel</a>
							</td>
						</tr>
					</tbody>
				</table>
				</form>
			<?php

	}
	
//EDIT-DELETE MENU SCREEN______________________________________________________	

	else if ($mode == "editmenu"){
		$message = (isset($_GET['error']) && $_GET['error'] == "namefield") ?  "<span style='color:red;'>Please give your menu a name.</span>" : "Menu Name";
		
		$mylink = $wpdb->get_row("SELECT * FROM $jsrm_menu_table WHERE id = $_GET[targetmenu]");
		$filter = $mylink->id;
		$menuname = esc_html(stripslashes($mylink->name));
		$q = "SELECT * FROM $jsrm_item_table WHERE menu = $filter ORDER by itemorder ASC";
		$result = $wpdb->get_results($q);
		
		
		?>
		
		<table class="widefat jsrm-admin-table">
			<thead>
				<tr><th colspan="4">Menu: <?php echo $menuname; ?></tr>
			</thead>
			<tbody>
				<tr><td>
				<form action="<?php echo $_SERVER["REQUEST_URI"]; ?>" method="post">
				<div><label for="name"><?php echo $message; ?></label><br/><input id="menu-title" type="text" name="name" value="<?php echo $menuname; ?>"/></div>
				<div><label for="desc">Description</label><br/><textarea id="menu-description" rows="8" name="desc"/><?php echo esc_textarea(stripslashes($mylink->description)); ?></textarea></div>
					<input type="hidden" name="dbtouch" value="updatemenu" />
					<input type="hidden" name="targetmenu" value="<?php echo $filter; ?>">
				<p><input type="submit" name="do" id="menu-submit" value="Update Menu"/></p>
				</form>
			</td>
			<td nowrap="nowrap"><a href="<?php echo $self; ?>">Cancel</a> | <a href="<?php echo $self."&dbtouch=deletemenu&targetmenu=".$filter; ?>" class="deletion">Delete This Menu</a>
			</td>
			
			</tr>
		</tbody>
		</table>
		
		
		<form action="<?php echo $_SERVER["REQUEST_URI"]; ?>" method="post">
		<table class="widefat jsrm-admin-table">
			<thead>
					<tr><th colspan="4">Add Item</tr>
			</thead>
			<tbody>
			<tr>
				<td><label>Item</label> <input type="text" name="item" id="add-item-field" value="" /></td>
				<td><label>Description</label> <input type="text" name="desc" id="add-desc-field" value="" /></td>
				<td><label>Value</label> <input type="text" name="value" id="add-value-field" value="" /></td>
				<td>
					<input type="hidden" name="dbtouch" value="additem" />
					<input type="hidden" name="mode" value="editmenu"/>
					<input type="hidden" name="targetmenu" value="<?php echo $filter; ?>">
					<input type="submit" value="Add"/></div> 
				</td>
			</tr>
			</tbody>
		</table>
		</form> 
			
		<?php
		if ($result) {
		?>
			<form action="<?php echo $_SERVER["REQUEST_URI"]; ?>" method="post">
			<table id="jsrm-current-item-list" class="widefat jsrm-admin-table">
				<thead>
					<tr><th>Current Items <small>( * Drag rows to reorder items)</small><th>Description</th><th>Value</th><th>Delete</th></tr>
				</thead>
				<tfoot>
					<tr class="nodrag">
					<td colspan="4">
						<input type="hidden" name="dbtouch" value="edititems" />
						<input type="hidden" name="mode" value="editmenu"/>
						<input type="hidden" name="targetmenu" value="<?php echo $filter; ?>">
						<input type="submit"  id="items-submit" value="Update Items"/>
					</td>
					</tr>
				</tfoot>
				<tbody>
					
				<?php
				foreach ($result as $r) {
					$order = $r->itemorder;
					$item = esc_html(stripslashes( $r->item ));
					$value = esc_html(stripslashes($r->value));
					$description = esc_html(stripslashes($r->description));
					$id = $r->id;
				?>
					
				<tr id="<?php echo $id ?>">
					<td><input type="text" class="edit-item-field" name="item[<?php echo $id ?>]" value="<?php echo $item ?>" /></td>
					<td><input type="text" class="edit-desc-field" name="desc[<?php echo $id ?>]" value="<?php echo $description ?>" id="desc<?php echo $id ?>"/></td>
					<td><input type="text" class="edit-value-field" name="value[<?php echo $id ?>]" value="<?php echo $value ?>" /></td>
					<td class="delete-cell"><input type="checkbox" class="strike" name="strike[<?php echo $id ?>]" value="checked"/></td>
						<input type="hidden" name="order[<?php echo $id ?>]" value="<?php echo $order ?>" id="order<?php echo $id ?>"/>
						<input type="hidden" name="id[<?php echo $id ?>]" value="<?php echo $id ?>" id="id<?php echo $id ?>"/>
				</tr>

				<?php
				}
				?>	
			</tbody></table/></form>
			
			
						<!- ->
			
	
		<h3>Get Menu Shortcode</h3>
		<p>In order to display this menu anywhere in your Wordpress website, you must include a "shortcode" in a page or post.</p>
		<p>Select your options, then copy and paste the resulting shortcode into any page or post.</p>
			
			<table id="jsrm-shortcode" class="jsrm-admin-table">
					<input type="hidden" name="dbtouch" value="editshortcode" />
					<input type="hidden" name="targetmenu" id="targetmenu" value="<?php echo esc_html(stripslashes($mylink->name)); ?>">
				<tr>
					<th scope="row"><label for="selectclass">Menu container style:</label></th>
					<td><select class="shortcodeselecter" id="selectclass">
						<option selected="selected">basic</option>
						<option>light</option>
    					<option>dark</option>
    					<option>custom</option>
						</select>
						<input type="text" class="customclass" id="selectcustomclass" value=""/> <small class="customclass" style="color:red;">* Custom style class must be defined in your style sheet.</small></td>
				</tr>
				<tr>
					<th scope="row"><label for="selectheader">Display menu name as:</label></th>
					<td><select class="shortcodeselecter" id="selectheader">
						<option>p</option>
						<option>h1</option>
    					<option selected="selected">h2</option>
    					<option>h3</option>
						<option>h4</option>
						<option>h5</option>
						<option>h6</option>
						<option>span</option>
						<option>div</option>
						<option>none</option>
						</select> <small>* Default value is 'h2' (Heading 2) and does not need to be included in the shortcode.</small>
					</td>
				</tr>
				<tr>
					<th scope="row"><label for="selectdesc">Display menu description as:</label></th>
					<td><select class="shortcodeselecter" id="selectdesc" name="selectdesc">
						<option selected="selected">p</option>
						<option>h1</option>
    					<option>h2</option>
    					<option>h3</option>
						<option>h4</option>
						<option>h5</option>
						<option>h6</option>
						<option>span</option>
						<option>div</option>
						<option>none</option>
						</select> <small>* Default value is 'p' (paragraph) and does not need to be included in the shortcode.</small>
					</td>
				</tr>
				<tr>
					<th scope="row"><label for="selectdisplay">Display menu as:</label></th>
					<td><select  class="shortcodeselecter" id="selectdisplay">
						<option selected="selected">table</option>
						<option>ordered list</option>
    					<option>unordered list</option>
    					<option>definition list</option>
						<option>divs</option>
						</select> <small>* Default value is 'table' and does not need to be included in the shortcode.</small>
					</td>
				</tr>
				<tr>
					<th scope="row"><strong>Shortcode:</strong></td>
					<td>
						<textarea id="shortcodeoutput" rows="2" value="nan" readonly="readonly"/></textarea>
					</td>
				</td></tr>
			</table>
			
			
			
			
			
			<!- ->
			
		
			<?php
		}
	}
			


	?>
	</div>
<?php	
}